//
// Copyright (C) 2015 The Android Open Source Project
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

#ifndef SHILL_STORE_FACTORY_H_
#define SHILL_STORE_FACTORY_H_

#include <base/lazy_instance.h>

namespace base {
class FilePath;
}

namespace shill {

class StoreInterface;

class StoreFactory {
 public:
  // This is a singleton. Use StoreFactory::GetInstance()->Foo().
  static StoreFactory* GetInstance();

  StoreInterface* CreateStore(const base::FilePath& path);

 protected:
  StoreFactory();

 private:
  friend struct base::DefaultLazyInstanceTraits<StoreFactory>;

  DISALLOW_COPY_AND_ASSIGN(StoreFactory);
};

}  // namespace shill

#endif  // SHILL_STORE_FACTORY_H_
